
-- Hooks # Start ------------------------------------
addhook("second","crb_sec")			--|
addhook("say","crb_say")        	--|
addhook("sayteam","crb_sayteam")    --|
addhook("leave","crb_leave")		--|
addhook("die","crb_die")			--|
addhook("always","crb_alw")			--|
addhook("startround","crb_startr")	--|
addhook("join","crb_join")			--|
-- Hooks # End --------------------------------------

-- Defines # Start --------------------

MOTOP_engine = 'On' -- Turn it On or Off here (work or stop working)
msg_show_time = 8 -- In secs
msg_def_color = '255255255' -- Msg default color in rgb
msg_show_default = true -- Indicate that messages be shown in the left as default ! (true is default)
msg_hudscale = true -- If you are running the server on new game version resolution (850x480) turn it on(true)
msg_binds = true -- Binds are allowed or not ?

function initArray(m) -- Creating arrays
	local array = {}
	for i = 1, m do
		array[i]=0
	end
	return array
end

player_msg=initArray(32)
player_team_msg=initArray(32)
player_msg_dealy=initArray(32)
player_team_msg_dealy=initArray(32)

-- Defines # End ---------------------- 


-- Function # Start --------------------

function crb_startr()
	if (hudscale == true) then
		parse("mp_hudscale 1") -- Scale to fit screen if script is written for 850x480 resolution
	end
	
end

function crb_join(id) -- Bind some frequent chats here
	if (msg_binds == true) then
		-- parse('bind "H" "say Hello"')
		-- parse('bind "J" "say Goodbye"')
		-- parse('bind "K" "say Follow me"')
		-- ...
	end
end

function crb_say(id,txt) -- Creat msg
	if (MOTOP_engine == 'On') then
		if (string.sub(txt, 1, 1) ~= '-') then	
			if (player(id,"exists") and player(id,"health") > 0) then
				player_msg[id] = txt
				player_msg_dealy[id] = msg_show_time -- Is 8 secs by default
			end

			if (msg_show_default == false) then
				return 1 -- Avoid message to be showed
			end
		end
	end
end

function crb_sayteam(id,txt) -- Creat team msg

	if (player(id,"exists") and player(id,"health") > 0) then
		player_team_msg[id] = txt
		player_team_msg_dealy[id] = msg_show_time
	end

	if (msg_show_default == false) then
		return 1  
	end

end

function crb_alw() -- Showing
	local playerlist=player(0,"table")
	for _,n in pairs(playerlist) do
		if (player(n,"exists")) then
			p1_x = player(n,"x")
			p1_y = player(n,"y")
			for _,i in pairs(playerlist) do
	if (player(i,"exists")) then -- Player existance check
		if (player_msg_dealy[i] ~= 0) then
			p2_x = player(i,"x")
			p2_y = player(i,"y")
			distance = math.sqrt((p2_x-p1_x)^2 + (p2_y-p1_y)^2) -- Calculate the distance
			if (distance < 600) then -- If player is near
			hut_width = math.floor(string.len(player_msg[i])*6) -- Estimate hud width (every character is about 6)
			hud_x = 425 - (hut_width)/2 + (p2_x-p1_x) -- Put the hud in the center
			hud_y = 240 + (p2_y-p1_y) - 40
			hudtxt2(n,i,msg_def_color..player_msg[i],hud_x,hud_y,0)
		end
	else
			hudtxt2(n,i,"",0,0,0) -- Empty hud
		end
		-- Team message
		if (player_team_msg_dealy[i] > player_msg_dealy[i]) then -- If the last message was team message
			if (player_team_msg_dealy[i] ~= 0 and player(i,'team') == player(n,'team')) then
				p2_x = player(i,"x")
				p2_y = player(i,"y")
				distance = math.sqrt((p2_x-p1_x)^2 + (p2_y-p1_y)^2)
				if (distance < 600) then
					hut_width = math.floor((string.len(player_team_msg[i])+4)*6)		
			hud_x = 425 - (hut_width)/2 + (p2_x-p1_x) -- Put the hud in the center
			hud_y = 240 + (p2_y-p1_y) - 40
			hudtxt2(n,i,"000255128 [S] "..msg_def_color..player_team_msg[i],hud_x,hud_y,0)		
		end
	else
		hudtxt2(n,i,"",0,0,0)
	end
end
end 
end 
end
end

end

function crb_sec() -- Hiding
		local playerlist=player(0,"table")
		for _,n in pairs(playerlist) do
			if (player_msg_dealy[n] > 0) then
		player_msg_dealy[n] = player_msg_dealy[n] - 1 -- Increase Delay by 1 in a sec
	else
		player_msg[n] = '' -- If delay in less than 1 hide the hud
	end

	if (player_team_msg_dealy[n] > 0) then
		player_team_msg_dealy[n] = player_team_msg_dealy[n] - 1
	else
		player_team_msg[n] = ''
	end
		end	
end

function crb_die(id) -- Hiding after player die
	player_msg_dealy[id] = 0
	player_team_msg_dealy[n] = 0
	player_msg[id] = 0
	player_team_msg[id] = 0
	local playerlist=player(0,"table")
	for _,n in pairs(playerlist) do
		hudtxt2(n,id,"",0,0,0)
	end
end

function crb_leave(id) -- Hiding after player leave game
	player_msg_dealy[id] = 0
	player_msg[id] = 0
	player_team_msg_dealy[id] = 0
	player_team_msg[id] = 0
	local playerlist=player(0,"table")
	for _,n in pairs(playerlist) do
		hudtxt2(n,id,"",0,0,0)
	end
end

-- Function # End ----------------------

-- Lua by carb0n - 2017 
-- Version 1.0.3